"use strict";

const conversions = require("webidl-conversions");
const utils = require("./utils.js");
const {proxy} = require("./utils");

const implSymbol = utils.implSymbol;
const ctorRegistrySymbol = utils.ctorRegistrySymbol;

const interfaceName = "Navigator";

exports.is = value => {
    return utils.isObject(value) && utils.hasOwn(value, implSymbol) && value[implSymbol] instanceof Impl.implementation;
};
exports.isImpl = value => {
    return utils.isObject(value) && value instanceof Impl.implementation;
};
exports.convert = (value, {context = "The provided value"} = {}) => {
    if (exports.is(value)) {
        return utils.implForWrapper(value);
    }
    throw new TypeError(`${context} is not of type 'Navigator'.`);
};

function makeWrapper(globalObject) {
    if (globalObject[ctorRegistrySymbol] === undefined) {
        throw new Error("Internal error: invalid global object");
    }

    const ctor = globalObject[ctorRegistrySymbol]["Navigator"];
    if (ctor === undefined) {
        throw new Error("Internal error: constructor Navigator is not installed on the passed global object");
    }

    return Object.create(ctor.prototype);
}

exports.create = (globalObject, constructorArgs, privateData) => {
    const wrapper = makeWrapper(globalObject);
    return exports.setup(wrapper, globalObject, constructorArgs, privateData);
};

exports.createImpl = (globalObject, constructorArgs, privateData) => {
    const wrapper = exports.create(globalObject, constructorArgs, privateData);
    return utils.implForWrapper(wrapper);
};

exports._internalSetup = (wrapper, globalObject) => {
};

exports.setup = (wrapper, globalObject, constructorArgs = [], privateData = {}) => {
    privateData.wrapper = wrapper;

    exports._internalSetup(wrapper, globalObject);
    Object.defineProperty(wrapper, implSymbol, {
        value: new Impl.implementation(globalObject, constructorArgs, privateData),
        configurable: true
    });

    wrapper[implSymbol][utils.wrapperSymbol] = wrapper;
    if (Impl.init) {
        Impl.init(wrapper[implSymbol]);
    }
    return wrapper;
};

exports.new = globalObject => {
    const wrapper = makeWrapper(globalObject);

    exports._internalSetup(wrapper, globalObject);
    Object.defineProperty(wrapper, implSymbol, {
        value: Object.create(Impl.implementation.prototype),
        configurable: true
    });

    wrapper[implSymbol][utils.wrapperSymbol] = wrapper;
    if (Impl.init) {
        Impl.init(wrapper[implSymbol]);
    }
    return wrapper[implSymbol];
};

const exposed = new Set(["Window"]);
var v_saf;
!function () {
    var n = Function.toString, t = [], i = [], o = [].indexOf.bind(t), e = [].push.bind(t), r = [].push.bind(i);

    function u(n, t, tag) {
        return -1 == o(n) && (e(n), r(`function ${tag ? tag : ""}${t || n.name || ""}() { [native code] }`.replaceAll('get get', 'get'))), n
    }

    Object.defineProperty(Function.prototype, "toString", {
        enumerable: !1,
        configurable: !0,
        writable: !0,
        value: function () {
            return "function" == typeof this && i[o(this)] || n.call(this)
        }
    }), u(Function.prototype.toString, "toString"), v_saf = u
}();
exports.install = (globalObject, globalNames) => {
    if (!globalNames.some(globalName => exposed.has(globalName))) {
        return;
    }

    class MimeTypeArray {
        get length() {
            return 2;
        }

        item() {
            return mims[arguments[0]]
            return null;
        }

        namedItem() {
            return null;
        }

        get [idlUtils.supportedPropertyIndices]() {
            return [];
        }
    };
    Object.defineProperties(MimeTypeArray.prototype, {
        [Symbol.toStringTag]: {value: "MimeTypeArray", writable: false, enumerable: false, configurable: true},

    })
    // Object.defineProperties(MimeTypeArray.prototype, {
    //     '0': {
    //         value: {},
    //         enumerable: true,
    //         writable: true
    //     },
    //     '1': {
    //         value: {},
    //         enumerable: true,
    //         writable: true
    //     }, 'application/pdf': {
    //         value: {},
    //         enumerable: false,
    //         writable: true
    //     }, 'text/pdf': {
    //         value: {},
    //         enumerable: false,
    //         writable: true
    //     }
    // })

    class Navigator {
        constructor() {
            throw new TypeError("Illegal constructor");
        }

        javaEnabled() {

            const esValue = this !== null && this !== undefined ? this : globalObject;
            if (!exports.is(esValue)) {
                throw new TypeError("'javaEnabled' called on an object that is not a valid instance of Navigator.");
            }

            return esValue[implSymbol].javaEnabled();
        }

        get appCodeName() {
            return window.ENV.navigatorparams.appcodename

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get appCodeName' called on an object that is not a valid instance of Navigator.");
            }

            return esValue[implSymbol]["appCodeName"];
        }

        get appName() {
            return window.ENV.navigatorparams.appname

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get appName' called on an object that is not a valid instance of Navigator.");
            }

            return esValue[implSymbol]["appName"];
        }

        get appVersion() {
            return window.ENV.navigatorparams.appversion

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get appVersion' called on an object that is not a valid instance of Navigator.");
            }

            return esValue[implSymbol]["appVersion"];
        }

        get platform() {
            return window.ENV.navigatorparams.platform
            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get platform' called on an object that is not a valid instance of Navigator.");
            }

            return esValue[implSymbol]["platform"];
        }

        get product() {
            return window.ENV.navigatorparams.product

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get product' called on an object that is not a valid instance of Navigator.");
            }

            return esValue[implSymbol]["product"];
        }

        get productSub() {
            return window.ENV.navigatorparams.productsub

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get productSub' called on an object that is not a valid instance of Navigator.");
            }

            return esValue[implSymbol]["productSub"];
        }

        get userAgentData() {
            return {
                "brands": [{"brand": "Not/A)Brand", "version": "99"}, {
                    "brand": "Google Chrome",
                    "version": "115"
                }, {"brand": "Chromium", "version": "115"}], "mobile": false, "platform": "macOS",
                getHighEntropyValues: function (e) {
                    console.log('getHighEntropyValues', e)
                    let r;
                    switch (e[0]) {
                        case 'architecture':
                            r = {
                                "architecture": "arm",
                                "brands": [
                                    {
                                        "brand": "Not/A)Brand",
                                        "version": "99"
                                    },
                                    {
                                        "brand": "Google Chrome",
                                        "version": "115"
                                    },
                                    {
                                        "brand": "Chromium",
                                        "version": "115"
                                    }
                                ],
                                "mobile": false,
                                "platform": "macOS"
                            }
                            break;
                        case 'bitness':
                            r = {
                                "bitness": "64",
                                "brands": [{"brand": "Not/A)Brand", "version": "99"}, {
                                    "brand": "Google Chrome",
                                    "version": "115"
                                }, {"brand": "Chromium", "version": "115"}],
                                "mobile": false,
                                "platform": "macOS"
                            }
                            break;
                        case 'brands':
                            r = {
                                "brands": [{"brand": "Not/A)Brand", "version": "99"}, {
                                    "brand": "Google Chrome",
                                    "version": "115"
                                }, {"brand": "Chromium", "version": "115"}], "mobile": false, "platform": "macOS"
                            }
                            break;
                        case 'mobile':
                            r = {
                                "brands": [{"brand": "Not.A/Brand", "version": "8"}, {
                                    "brand": "Chromium",
                                    "version": "114"
                                }, {"brand": "Google Chrome", "version": "114"}], "mobile": false, "platform": "macOS"
                            }
                            break;
                        case 'model':
                            r = {
                                "brands": [{"brand": "Not.A/Brand", "version": "8"}, {
                                    "brand": "Chromium",
                                    "version": "114"
                                }, {"brand": "Google Chrome", "version": "114"}],
                                "mobile": false,
                                "model": "",
                                "platform": "macOS"
                            }
                            break;
                        case 'platform':
                            r = {
                                "brands": [{"brand": "Not/A)Brand", "version": "99"}, {
                                    "brand": "Google Chrome",
                                    "version": "115"
                                }, {"brand": "Chromium", "version": "115"}], "mobile": false, "platform": "macOS"
                            }
                            break;
                        case 'platformVersion':
                            r = {
                                "brands": [{"brand": "Not/A)Brand", "version": "99"}, {
                                    "brand": "Google Chrome",
                                    "version": "115"
                                }, {"brand": "Chromium", "version": "115"}],
                                "mobile": false,
                                "platform": "macOS",
                                "platformVersion": "13.5.0"
                            }
                            break;
                        case 'uaFullVersion':
                            r = {
                                "brands": [{"brand": "Not/A)Brand", "version": "99"}, {
                                    "brand": "Google Chrome",
                                    "version": "115"
                                }, {"brand": "Chromium", "version": "115"}],
                                "mobile": false,
                                "platform": "macOS",
                                "uaFullVersion": "115.0.5790.114"
                            }
                            break;
                        case 'wow64':
                            r = {
                                "brands": [{"brand": "Not/A)Brand", "version": "99"}, {
                                    "brand": "Google Chrome",
                                    "version": "115"
                                }, {"brand": "Chromium", "version": "115"}],
                                "mobile": false,
                                "platform": "macOS",
                                "wow64": false
                            }
                            break;
                        case 'fullVersionList':
                            r = {
                                "brands": [{"brand": "Not/A)Brand", "version": "99"}, {
                                    "brand": "Google Chrome",
                                    "version": "115"
                                }, {"brand": "Chromium", "version": "115"}],
                                "fullVersionList": [{
                                    "brand": "Not/A)Brand",
                                    "version": "99.0.0.0"
                                }, {"brand": "Google Chrome", "version": "115.0.5790.114"}, {
                                    "brand": "Chromium",
                                    "version": "115.0.5790.114"
                                }],
                                "mobile": false,
                                "platform": "macOS"
                            }
                            break;


                    }

                    return Promise((resolve, reject) => {

                        resolve(r)
                    });
                }
            }
        }

        get userAgent() {
            // return 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/115.0.0.0 Safari/537.36';
            return window.ENV.navigatorparams.useragent

            // return window.browser.ua;
            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get userAgent' called on an object that is not a valid instance of Navigator.");
            }

            return esValue[implSymbol]["userAgent"];
        }

        get vendor() {
            return window.ENV.navigatorparams.vendor

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get vendor' called on an object that is not a valid instance of Navigator.");
            }

            return esValue[implSymbol]["vendor"];
        }

        get vendorSub() {
            return window.ENV.navigatorparams.vendorsub

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get vendorSub' called on an object that is not a valid instance of Navigator.");
            }

            return esValue[implSymbol]["vendorSub"];
        }

        get language() {
            return window.ENV.navigatorparams.language ||
                "en-US"

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get language' called on an object that is not a valid instance of Navigator.");
            }

            return esValue[implSymbol]["language"];
        }

        get languages() {
            return window.ENV.navigatorparams.languages || [
                "en-US",
                "en",
                "zh-CN",
                "ru"]

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get languages' called on an object that is not a valid instance of Navigator.");
            }

            return utils.tryWrapperForImpl(esValue[implSymbol]["languages"]);
        }

        get onLine() {
            // return window.ENV.navigatorparams.onLine


            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get onLine' called on an object that is not a valid instance of Navigator.");
            }

            return esValue[implSymbol]["onLine"];
        }

        get cookieEnabled() {
            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get cookieEnabled' called on an object that is not a valid instance of Navigator.");
            }

            return esValue[implSymbol]["cookieEnabled"];
        }


        get hardwareConcurrency() {
            return window.ENV.navigatorparams.hardwareconcurrency

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get hardwareConcurrency' called on an object that is not a valid instance of Navigator.");
            }

            return esValue[implSymbol]["hardwareConcurrency"];
        }


        getUserMedia() {

            console.log('navigator.getUserMedia')
        }

        get maxTouchPoints() {
            console.log('navigator.maxTouchPoints.get')
            return 0
        }

        scheduling() {
            console.log('navigator.scheduling.object')
            return proxy({}, 'scheduling')
        }

        userActivation() {
            console.log('navigator.userActivation.object')
            return proxy({}, 'userActivation')
        }

        get doNotTrack() {
            console.log('navigator.doNotTrack.object')
            return null
        }

        geolocation() {
            console.log('navigator.geolocation.object')
            return proxy({}, 'geolocation')
        }

        get connection() {
            console.log('navigator.connection.object')
            return proxy({
                rtt : 100
            }, 'connection')
        }

        get pdfViewerEnabled() {
            console.log('navigator.pdfViewerEnabled.get')
        }

        webkitTemporaryStorage() {
            console.log('navigator.webkitTemporaryStorage.object')
            return proxy({}, 'webkitTemporaryStorage')
        }

        webkitPersistentStorage() {
            console.log('navigator.webkitPersistentStorage.object')
            return proxy({}, 'webkitPersistentStorage')
        }

        get webdriver() {
            console.log('navigator.webdriver.get')
        }

        getGamepads() {
            console.log('navigator.getGamepads')
        }

        sendBeacon() {
            console.log('navigator.sendBeacon')
        }

        vibrate() {
            console.log('navigator.vibrate')
        }

        bluetooth() {
            console.log('navigator.bluetooth.object')
            return proxy({}, 'bluetooth')
        }

        clipboard() {
            console.log('navigator.clipboard.object')
            return proxy({}, 'clipboard')
        }

        credentials() {
            console.log('navigator.credentials.object')
            return proxy({}, 'credentials')
        }

        keyboard() {
            console.log('navigator.keyboard.object')
            return proxy({}, 'keyboard')
        }

        managed() {
            console.log('navigator.managed.object')
            return proxy({}, 'managed')
        }

        mediaDevices() {
            console.log('navigator.mediaDevices.object')
            return proxy({}, 'mediaDevices')
        }

        storage() {
            console.log('navigator.storage.object')
            return proxy({}, 'storage')
        }

        serviceWorker() {
            console.log('navigator.serviceWorker.object')
            return proxy({}, 'serviceWorker')
        }

        virtualKeyboard() {
            console.log('navigator.virtualKeyboard.object')
            return proxy({}, 'virtualKeyboard')
        }

        wakeLock() {
            console.log('navigator.wakeLock.object')
            return proxy({}, 'wakeLock')
        }

        get deviceMemory() {
            console.log('navigator.deviceMemory.get')
        }

        ink() {
            console.log('navigator.ink.object')
            return proxy({}, 'ink')
        }

        hid() {
            console.log('navigator.hid.object')
            return proxy({}, 'hid')
        }

        locks() {
            console.log('navigator.locks.object')
            return proxy({}, 'locks')
        }

        mediaCapabilities() {
            console.log('navigator.mediaCapabilities.object')
            return proxy({}, 'mediaCapabilities')
        }

        mediaSession() {
            console.log('navigator.mediaSession.object')
            return proxy({}, 'mediaSession')
        }

        permissions() {
            console.log('navigator.permissions.object')
            return proxy({}, 'permissions')
        }

        presentation() {
            console.log('navigator.presentation.object')
            return proxy({}, 'presentation')
        }

        serial() {
            console.log('navigator.serial.object')
            return proxy({}, 'serial')
        }

        gpu() {
            console.log('navigator.gpu.object')
            return proxy({}, 'gpu')
        }

        usb() {
            console.log('navigator.usb.object')
            return proxy({}, 'usb')
        }

        windowControlsOverlay() {
            console.log('navigator.windowControlsOverlay.object')
            return proxy({}, 'windowControlsOverlay')
        }

        xr() {
            console.log('navigator.xr.object')
            return proxy({}, 'xr')
        }

        userAgentData() {
            console.log('navigator.userAgentData.object')
            return proxy({}, 'userAgentData')
        }

        clearAppBadge() {
            console.log('navigator.clearAppBadge')
        }

        getBattery() {
            console.log('navigator.getBattery')
        }

        requestMIDIAccess() {
            console.log('navigator.requestMIDIAccess')
        }

        requestMediaKeySystemAccess() {
            console.log('navigator.requestMediaKeySystemAccess')
        }

        setAppBadge() {
            console.log('navigator.setAppBadge')
        }

        webkitGetUserMedia() {
            console.log('navigator.webkitGetUserMedia')
        }

        getInstalledRelatedApps() {
            console.log('navigator.getInstalledRelatedApps')
        }

        registerProtocolHandler() {
            console.log('navigator.registerProtocolHandler')
        }

        unregisterProtocolHandler() {
            console.log('navigator.unregisterProtocolHandler')
        }

        get mimeTypes() {
            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get mimeTypes' called on an object that is not a valid instance of Navigator.");
            }

            let res = utils.getSameObject(this, "mimeTypes", () => {
                return utils.tryWrapperForImpl(esValue[implSymbol]["mimeTypes"]);
            });
            res = new MimeTypeArray();
            res['0'] = {
                suffixes:'pdf',
                type: "application/pdf",
                enabledPlugin: {
                    filename: "internal-pdf-viewer"
                }
            }
            res['1'] ={"suffixes":"pdf","type":"text/pdf","enabledPlugin":{"filename":"internal-pdf-viewer"}}
            res['application/pdf'] = {"suffixes":"pdf","type":"application/pdf","enabledPlugin":{"filename":"internal-pdf-viewer"}}
            res['text/pdf'] = {"suffixes":"pdf","type":"text/pdf","enabledPlugin":{"filename":"internal-pdf-viewer"}}
            return res
            // return proxy(res, 'mimeTypes')
        }
    }


    var v_saf;
    !function () {
        var n = Function.toString, t = [], i = [], o = [].indexOf.bind(t), e = [].push.bind(t), r = [].push.bind(i);

        function u(n, t, tag) {
            return -1 == o(n) && (e(n), r(`function ${tag ? tag : ""}${t || n.name || ""}() { [native code] }`.replaceAll('get get', 'get').replaceAll('set set', 'set'))), n
        }

        Object.defineProperty(Function.prototype, "toString", {
            enumerable: !1,
            configurable: !0,
            writable: !0,
            value: function () {
                return "function" == typeof this && i[o(this)] || n.call(this)
            }
        }), u(Function.prototype.toString, "toString"), v_saf = u
    }();
    let r = {}
    Object.keys(Object.getOwnPropertyDescriptors(Navigator.prototype)).forEach(e => {
        r[e] = {}
        if (Object.getOwnPropertyDescriptor(Navigator.prototype, e)['value']) {
            r[e]['value'] = v_saf(Object.getOwnPropertyDescriptor(Navigator.prototype, e)['value'])
        }

        if (Object.getOwnPropertyDescriptor(Navigator.prototype, e)['get']) {
            r[e]['get'] = v_saf(Object.getOwnPropertyDescriptor(Navigator.prototype, e)['get'], undefined, 'get ')
        }
        if (Object.getOwnPropertyDescriptor(Navigator.prototype, e)['set']) {
            r[e]['set'] = v_saf(Object.getOwnPropertyDescriptor(Navigator.prototype, e)['set'], undefined, 'set ')
        }
        r[e]['enumerable'] = true
    })
    Object.defineProperties(Navigator.prototype, r)

    Object.defineProperties(Navigator.prototype, {
        javaEnabled: {enumerable: true},
        appCodeName: {enumerable: true},
        appName: {enumerable: true},
        appVersion: {enumerable: true},
        platform: {enumerable: true},
        product: {enumerable: true},
        productSub: {enumerable: true},
        userAgent: {enumerable: true},
        vendor: {enumerable: true},
        vendorSub: {enumerable: true},
        language: {enumerable: true},
        languages: {enumerable: true},
        onLine: {enumerable: true},
        cookieEnabled: {enumerable: true},
        plugins: {
            enumerable: true,
            get: v_saf(function plugins() {
                const esValue = this !== null && this !== undefined ? this : globalObject;

                if (!exports.is(esValue)) {
                    throw new TypeError("'get plugins' called on an object that is not a valid instance of Navigator.");
                }

                return utils.getSameObject(this, "plugins", () => {
                    return utils.tryWrapperForImpl(esValue[implSymbol]["plugins"]);
                });
            }, undefined, 'get ')

        },
        mimeTypes: {enumerable: true},
        hardwareConcurrency: {enumerable: true},
        getUserMedia: {enumerable: true},
        maxTouchPoints: {enumerable: true},
        scheduling: {enumerable: true},
        userActivation: {enumerable: true},
        doNotTrack: {enumerable: true},
        geolocation: {enumerable: true},
        connection: {enumerable: true},
        pdfViewerEnabled: {enumerable: true},
        webkitTemporaryStorage: {enumerable: true},
        webkitPersistentStorage: {enumerable: true},
        webdriver: {enumerable: true},
        getGamepads: {enumerable: true},
        sendBeacon: {enumerable: true},
        vibrate: {enumerable: true},
        bluetooth: {enumerable: true},
        clipboard: {enumerable: true},
        credentials: {enumerable: true},
        keyboard: {enumerable: true},
        managed: {enumerable: true},
        mediaDevices: {enumerable: true},
        storage: {enumerable: true},
        serviceWorker: {enumerable: true},
        virtualKeyboard: {enumerable: true},
        wakeLock: {enumerable: true},
        deviceMemory: {enumerable: true},
        ink: {enumerable: true},
        hid: {enumerable: true},
        locks: {enumerable: true},
        mediaCapabilities: {enumerable: true},
        mediaSession: {enumerable: true},
        permissions: {enumerable: true},
        presentation: {enumerable: true},
        serial: {enumerable: true},
        gpu: {enumerable: true},
        usb: {enumerable: true},
        windowControlsOverlay: {enumerable: true},
        xr: {enumerable: true},
        userAgentData: {enumerable: true},
        clearAppBadge: {enumerable: true},
        getBattery: {enumerable: true},
        requestMIDIAccess: {enumerable: true},
        requestMediaKeySystemAccess: {enumerable: true},
        setAppBadge: {enumerable: true},
        webkitGetUserMedia: {enumerable: true},
        getInstalledRelatedApps: {enumerable: true},
        registerProtocolHandler: {enumerable: true},
        unregisterProtocolHandler: {enumerable: true},
        [Symbol.toStringTag]: {value: "Navigator", configurable: true}
    });

    if (globalObject[ctorRegistrySymbol] === undefined) {
        globalObject[ctorRegistrySymbol] = Object.create(null);
    }
    globalObject[ctorRegistrySymbol][interfaceName] = Navigator;

    Object.defineProperty(globalObject, interfaceName, {
        configurable: true,
        writable: true,
        value: utils.proxy(Navigator, 'Navigator')
    });
};

const Impl = require("../navigator/Navigator-impl.js");
const idlUtils = require("./utils");
